
import pyFluidSynth.fluidsynth
from time import sleep

def play_note(fs, note, life, channel, volume):
    '''note from 0 to 127 but all values are not possible in all bank
    life 0 to ~
    channel 1 to 16
    volume 0 to 127'''
    fs.noteon(channel, note, volume)
    sleep(life)
    fs.noteoff(channel, note)

def set_audio():
    '''Set fluidsynth, be carefull with fonts path'''
    try:
        import pyFluidSynth.fluidsynth as fluidsynth
    
        global fs
        fs = fluidsynth.Synth()
        fs.start(driver='alsa')
        # This path is a problem because it's absolute
        sfid = fs.sfload("/usr/share/sounds/sf2/FluidR3_GM.sf2")

        # .program_select(channel,    sfid,   bank,   bank number)
        fs.program_select(  1  ,      sfid,   0,      0  ) # yamaha grand piano
        fs.program_select(  2  ,      sfid,   0,      40 ) # violin
        fs.program_select(  3  ,      sfid,   0,      37 ) # pop bass
        fs.program_select(  4  ,      sfid,   0,      56 ) # trompet
        fs.program_select(  5  ,      sfid,   0,      66 ) # tenor sax
        fs.program_select(  6  ,      sfid,   0,      114) # steel drums
        fs.program_select(  7  ,      sfid,   0,      118) # synth drum
        fs.program_select(  8  ,      sfid,   0,      119) # reverse cymbal
        fs.program_select(  9  ,      sfid,   0,      116) # taiko drum
        fs.program_select(  10  ,     sfid,   0,      73 ) # flute
        fs.program_select(  11  ,     sfid,   0,      70 ) # basson
        fs.program_select(  12  ,     sfid,   0,      46 ) # harp
        fs.program_select(  13  ,     sfid,   0,      13 ) # xylophone
        fs.program_select(  14  ,     sfid,   0,      24 ) # nylon string guitar
        fs.program_select(  15  ,     sfid,   0,      25 ) # steel string guitar
        fs.program_select(  16  ,     sfid,   0,      29 ) # overdrive guitar

        return fs
    
    except:
        print "For sound synthetizer, you must install:"
        print "sudo apt-get install fluidsynth fluid-soundfont-gm fluid-soundfont-gs"
        print "Be carefull with Sound Font Path"
        pass
    
