#!/usr/bin/env python
# -*- coding: utf8 -*-

# WikikIRC est un petit script qui récupère le flux IRC du canal fr.wikipedia pour en faire des fichiers txt
# afin qu'ils soient lus et traduits en "MIDI" par Puredata via OSC.

# WikikIRC a été pondu par Olivier Baudu et Anthony Templier pour le Labomedia en septembre 2011.
# lamouraupeuple arobase gmail point com // http://lamomedia.net
# Publié sous license GPLv3 (http://www.gnu.org/licenses/gpl-3.0.html)

# python2.7 OSC in OSC directory
import OSC.OSC as OSC

# irclib and ircbot are in irclib directory
import irclib.irclib as irclib
import irclib.ircbot as ircbot

# re is regular expression
import re
from time import sleep

# my modules: I'm beginner with this
import pyfluidSynth_play.fluidsynth_play as fs_play

# Init OSC
blender_client = OSC.OSCClient()
blender_msg = OSC.OSCMessage()

Dictionary = {'a':0, 'b':1, 'c':2, 'd':3, 'e':4, 'f':5,
              'g':6, 'h':7, 'i':8, 'j':9, 'k':10, 'l':11,
              'm':12, 'n':13, 'o':14, 'p':15, 'q':16, 'r':17,
              's':18, 't':19, 'u':20, 'v':21, 'w':22, 'x':23,
              'y':24, 'z':25}
              
n = 0

print ("Connexion en cours sur l'IRC...")
    
class BotModeration(ircbot.SingleServerIRCBot):
    def __init__(self):
        # init IRC
        ircbot.SingleServerIRCBot.__init__(self, [("irc.wikimedia.org", 6667)], "Labomedia-test", "Bot d'analyse syntaxique réalisé en Python avec ircbot")
        
        # get only text without color code    
        self.filtre = re.compile( "\x03[0-9]{0,2}" )

    def on_welcome(self, serv, ev): 
        # IRC connection
        serv.join("#fr.wikipedia")
        global fs
        fs = fs_play.set_audio()
            
    def on_pubmsg(self, serv, ev):   
        message = ev.arguments()[0] # get new message
        sortie = self.filtre.sub('', message) # only new message
        global n
        n += 1
        # print message in console
        sortie = str(sortie)
        sortie = re.sub(r'[_,.;:^\W]', '', sortie)
        sortie = sortie.lower()
        print sortie
        channel = 1
        life = 0.1
        volume = 100
        for j in sortie:
            if n%4 == 0:
                channel = 9
                life = 0.5
            elif n%3 == 0:
                channel = 13
                life = 0.1
            else:
                channel = 1
                life = 0.1
            if j.isdigit():
                volume = 30 + 10*int(j)
            if not j.isdigit():
                sleep(0.01)
                note = 50 + 3*Dictionary[j]
                fs_play.play_note(fs, note, life, channel, volume)
        
        # send message to blender
        blender_msg.setAddress("/text")
        blender_msg.append(sortie)
        try:
            blender_client.sendto(blender_msg, ('127.0.0.1', 8000))
            blender_msg.clearData()
        except:
            print 'No connection with blender'
            pass        
        
if __name__ == "__main__":
    BotModeration().start()
